/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	/*! @preserve
	 *
	 * The MIT License (MIT)
	 *
	 * Copyright (c) 2014-2016 Giulio Canti
	 *
	 */

	// core
	var t = __webpack_require__(1);

	// types
	t.Any = __webpack_require__(6);
	t.Array = __webpack_require__(16);
	t.Boolean = __webpack_require__(17);
	t.Date = __webpack_require__(19);
	t.Error = __webpack_require__(20);
	t.Function = __webpack_require__(21);
	t.Nil = __webpack_require__(22);
	t.Number = __webpack_require__(23);
	t.Object = __webpack_require__(25);
	t.RegExp = __webpack_require__(26);
	t.String = __webpack_require__(27);

	// short alias are deprecated
	t.Arr = t.Array;
	t.Bool = t.Boolean;
	t.Dat = t.Date;
	t.Err = t.Error;
	t.Func = t.Function;
	t.Num = t.Number;
	t.Obj = t.Object;
	t.Re = t.RegExp;
	t.Str = t.String;

	// combinators
	t.dict = __webpack_require__(28);
	t.declare = __webpack_require__(34);
	t.enums = __webpack_require__(36);
	t.irreducible = __webpack_require__(7);
	t.list = __webpack_require__(37);
	t.maybe = __webpack_require__(38);
	t.refinement = __webpack_require__(40);
	t.struct = __webpack_require__(41);
	t.tuple = __webpack_require__(42);
	t.union = __webpack_require__(43);
	t.func = __webpack_require__(45);
	t.intersection = __webpack_require__(46);
	t.subtype = t.refinement;

	// functions
	t.assert = t;
	t.update = __webpack_require__(47);
	t.mixin = __webpack_require__(35);
	t.isType = __webpack_require__(12);
	t.is = __webpack_require__(33);
	t.getTypeName = __webpack_require__(11);
	t.match = __webpack_require__(48);

	module.exports = t;


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	var isFunction = __webpack_require__(2);
	var isNil = __webpack_require__(3);
	var fail = __webpack_require__(4);
	var stringify = __webpack_require__(5);

	function assert(guard, message) {
	  if (guard !== true) {
	    if (isFunction(message)) { // handle lazy messages
	      message = message();
	    }
	    else if (isNil(message)) { // use a default message
	      message = 'Assert failed (turn on "Pause on exceptions" in your Source panel)';
	    }
	    assert.fail(message);
	  }
	}

	assert.fail = fail;
	assert.stringify = stringify;

	module.exports = assert;

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = function isFunction(x) {
	  return typeof x === 'function';
	};

/***/ },
/* 3 */
/***/ function(module, exports) {

	module.exports = function isNil(x) {
	  return x === null || x === void 0;
	};

/***/ },
/* 4 */
/***/ function(module, exports) {

	module.exports = function fail(message) {
	  throw new TypeError('[tcomb] ' + message);
	};

/***/ },
/* 5 */
/***/ function(module, exports) {

	module.exports = function stringify(x) {
	  try { // handle "Converting circular structure to JSON" error
	    return JSON.stringify(x, null, 2);
	  }
	  catch (e) {
	    return String(x);
	  }
	};

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);

	module.exports = irreducible('Any', function () { return true; });


/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isString = __webpack_require__(9);
	var isFunction = __webpack_require__(2);
	var forbidNewOperator = __webpack_require__(10);

	module.exports = function irreducible(name, predicate) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isString(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to irreducible(name, predicate) (expected a string)'; });
	    assert(isFunction(predicate), 'Invalid argument predicate ' + assert.stringify(predicate) + ' supplied to irreducible(name, predicate) (expected a function)');
	  }

	  function Irreducible(value, path) {

	    if (process.env.NODE_ENV !== 'production') {
	      forbidNewOperator(this, Irreducible);
	      path = path || [name];
	      assert(predicate(value), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/'); });
	    }

	    return value;
	  }

	  Irreducible.meta = {
	    kind: 'irreducible',
	    name: name,
	    predicate: predicate,
	    identity: true
	  };

	  Irreducible.displayName = name;

	  Irreducible.is = predicate;

	  return Irreducible;
	};

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 8 */
/***/ function(module, exports) {

	// shim for using process in browser

	var process = module.exports = {};
	var queue = [];
	var draining = false;
	var currentQueue;
	var queueIndex = -1;

	function cleanUpNextTick() {
	    draining = false;
	    if (currentQueue.length) {
	        queue = currentQueue.concat(queue);
	    } else {
	        queueIndex = -1;
	    }
	    if (queue.length) {
	        drainQueue();
	    }
	}

	function drainQueue() {
	    if (draining) {
	        return;
	    }
	    var timeout = setTimeout(cleanUpNextTick);
	    draining = true;

	    var len = queue.length;
	    while(len) {
	        currentQueue = queue;
	        queue = [];
	        while (++queueIndex < len) {
	            if (currentQueue) {
	                currentQueue[queueIndex].run();
	            }
	        }
	        queueIndex = -1;
	        len = queue.length;
	    }
	    currentQueue = null;
	    draining = false;
	    clearTimeout(timeout);
	}

	process.nextTick = function (fun) {
	    var args = new Array(arguments.length - 1);
	    if (arguments.length > 1) {
	        for (var i = 1; i < arguments.length; i++) {
	            args[i - 1] = arguments[i];
	        }
	    }
	    queue.push(new Item(fun, args));
	    if (queue.length === 1 && !draining) {
	        setTimeout(drainQueue, 0);
	    }
	};

	// v8 likes predictible objects
	function Item(fun, array) {
	    this.fun = fun;
	    this.array = array;
	}
	Item.prototype.run = function () {
	    this.fun.apply(null, this.array);
	};
	process.title = 'browser';
	process.browser = true;
	process.env = {};
	process.argv = [];
	process.version = ''; // empty string to avoid regexp issues
	process.versions = {};

	function noop() {}

	process.on = noop;
	process.addListener = noop;
	process.once = noop;
	process.off = noop;
	process.removeListener = noop;
	process.removeAllListeners = noop;
	process.emit = noop;

	process.binding = function (name) {
	    throw new Error('process.binding is not supported');
	};

	process.cwd = function () { return '/' };
	process.chdir = function (dir) {
	    throw new Error('process.chdir is not supported');
	};
	process.umask = function() { return 0; };


/***/ },
/* 9 */
/***/ function(module, exports) {

	module.exports = function isString(x) {
	  return typeof x === 'string';
	};

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	var assert = __webpack_require__(1);
	var getTypeName = __webpack_require__(11);

	module.exports = function forbidNewOperator(x, type) {
	  assert(!(x instanceof type), function () { return 'Cannot use the new operator to instantiate the type ' + getTypeName(type); });
	};

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	var isType = __webpack_require__(12);
	var getFunctionName = __webpack_require__(15);

	module.exports = function getTypeName(constructor) {
	  if (isType(constructor)) {
	    return constructor.displayName;
	  }
	  return getFunctionName(constructor);
	};

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	var isFunction = __webpack_require__(2);
	var isObject = __webpack_require__(13);

	module.exports = function isType(x) {
	  return isFunction(x) && isObject(x.meta);
	};

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	var isNil = __webpack_require__(3);
	var isArray = __webpack_require__(14);

	module.exports = function isObject(x) {
	  return !isNil(x) && typeof x === 'object' && !isArray(x);
	};

/***/ },
/* 14 */
/***/ function(module, exports) {

	module.exports = function isArray(x) {
	  return x instanceof Array;
	};

/***/ },
/* 15 */
/***/ function(module, exports) {

	module.exports = function getFunctionName(f) {
	  return f.displayName || f.name || '<function' + f.length + '>';
	};

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);
	var isArray = __webpack_require__(14);

	module.exports = irreducible('Array', isArray);


/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);
	var isBoolean = __webpack_require__(18);

	module.exports = irreducible('Boolean', isBoolean);


/***/ },
/* 18 */
/***/ function(module, exports) {

	module.exports = function isBoolean(x) {
	  return x === true || x === false;
	};

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);

	module.exports = irreducible('Date', function (x) { return x instanceof Date; });


/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);

	module.exports = irreducible('Error', function (x) { return x instanceof Error; });


/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);
	var isFunction = __webpack_require__(2);

	module.exports = irreducible('Function', isFunction);


/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);
	var isNil = __webpack_require__(3);

	module.exports = irreducible('Nil', isNil);


/***/ },
/* 23 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);
	var isNumber = __webpack_require__(24);

	module.exports = irreducible('Number', isNumber);


/***/ },
/* 24 */
/***/ function(module, exports) {

	module.exports = function isNumber(x) {
	  return typeof x === 'number' && isFinite(x) && !isNaN(x);
	};

/***/ },
/* 25 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);
	var isObject = __webpack_require__(13);

	module.exports = irreducible('Object', isObject);


/***/ },
/* 26 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);

	module.exports = irreducible('RegExp', function (x) { return x instanceof RegExp; });


/***/ },
/* 27 */
/***/ function(module, exports, __webpack_require__) {

	var irreducible = __webpack_require__(7);
	var isString = __webpack_require__(9);

	module.exports = irreducible('String', isString);


/***/ },
/* 28 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var isFunction = __webpack_require__(2);
	var getTypeName = __webpack_require__(11);
	var isIdentity = __webpack_require__(30);
	var isObject = __webpack_require__(13);
	var create = __webpack_require__(31);
	var is = __webpack_require__(33);

	function getDefaultName(domain, codomain) {
	  return '{[key: ' + getTypeName(domain) + ']: ' + getTypeName(codomain) + '}';
	}

	function dict(domain, codomain, name) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isFunction(domain), function () { return 'Invalid argument domain ' + assert.stringify(domain) + ' supplied to dict(domain, codomain, [name]) combinator (expected a type)'; });
	    assert(isFunction(codomain), function () { return 'Invalid argument codomain ' + assert.stringify(codomain) + ' supplied to dict(domain, codomain, [name]) combinator (expected a type)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to dict(domain, codomain, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(domain, codomain);
	  var domainNameCache = getTypeName(domain);
	  var codomainNameCache = getTypeName(codomain);
	  var identity = isIdentity(domain) && isIdentity(codomain);

	  function Dict(value, path) {

	    if (process.env.NODE_ENV === 'production') {
	      if (identity) {
	        return value; // just trust the input if elements must not be hydrated
	      }
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      path = path || [displayName];
	      assert(isObject(value), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/'); });
	    }

	    var idempotent = true; // will remain true if I can reutilise the input
	    var ret = {}; // make a temporary copy, will be discarded if idempotent remains true
	    for (var k in value) {
	      if (value.hasOwnProperty(k)) {
	        k = create(domain, k, ( process.env.NODE_ENV !== 'production' ? path.concat(domainNameCache) : null ));
	        var actual = value[k];
	        var instance = create(codomain, actual, ( process.env.NODE_ENV !== 'production' ? path.concat(k + ': ' + codomainNameCache) : null ));
	        idempotent = idempotent && ( actual === instance );
	        ret[k] = instance;
	      }
	    }

	    if (idempotent) { // implements idempotency
	      ret = value;
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      Object.freeze(ret);
	    }

	    return ret;
	  }

	  Dict.meta = {
	    kind: 'dict',
	    domain: domain,
	    codomain: codomain,
	    name: name,
	    identity: identity
	  };

	  Dict.displayName = displayName;

	  Dict.is = function (x) {
	    if (!isObject(x)) {
	      return false;
	    }
	    for (var k in x) {
	      if (x.hasOwnProperty(k)) {
	        if (!is(k, domain) || !is(x[k], codomain)) {
	          return false;
	        }
	      }
	    }
	    return true;
	  };

	  Dict.update = function (instance, patch) {
	    return Dict(assert.update(instance, patch));
	  };

	  return Dict;
	}

	dict.getDefaultName = getDefaultName;
	module.exports = dict;

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	var isNil = __webpack_require__(3);
	var isString = __webpack_require__(9);

	module.exports = function isTypeName(name) {
	  return isNil(name) || isString(name);
	};

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var Boolean = __webpack_require__(17);
	var isType = __webpack_require__(12);
	var getTypeName = __webpack_require__(11);

	// return true if the type constructor behaves like the identity function
	module.exports = function isIdentity(type) {
	  if (isType(type)) {
	    if (process.env.NODE_ENV !== 'production') {
	      assert(Boolean.is(type.meta.identity), function () { return 'Invalid meta identity ' + assert.stringify(type.meta.identity) + ' supplied to type ' + getTypeName(type); });
	    }
	    return type.meta.identity;
	  }
	  // for tcomb the other constructors, like ES6 classes, are identity-like
	  return true;
	};
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var isType = __webpack_require__(12);
	var isStruct = __webpack_require__(32);
	var getFunctionName = __webpack_require__(15);
	var assert = __webpack_require__(1);
	var stringify = __webpack_require__(5);

	// creates an instance of a type, handling the optional new operator
	module.exports = function create(type, value, path) {
	  if (isType(type)) {
	    // for structs the new operator is allowed
	    return isStruct(type) ? new type(value, path) : type(value, path);
	  }

	  if (process.env.NODE_ENV !== 'production') {
	    // here type should be a class constructor and value some instance, just check membership and return the value
	    path = path || [getFunctionName(type)];
	    assert(value instanceof type, function () { return 'Invalid value ' + stringify(value) + ' supplied to ' + path.join('/'); });
	  }

	  return value;
	};
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 32 */
/***/ function(module, exports, __webpack_require__) {

	var isType = __webpack_require__(12);

	module.exports = function isStruct(x) {
	  return isType(x) && ( x.meta.kind === 'struct' );
	};

/***/ },
/* 33 */
/***/ function(module, exports, __webpack_require__) {

	var isType = __webpack_require__(12);

	// returns true if x is an instance of type
	module.exports = function is(x, type) {
	  if (isType(type)) {
	    return type.is(x);
	  }
	  return x instanceof type; // type should be a class constructor
	};


/***/ },
/* 34 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var isType = __webpack_require__(12);
	var isNil = __webpack_require__(3);
	var mixin = __webpack_require__(35);
	var getTypeName = __webpack_require__(11);

	// All the .declare-d types should be clearly different from each other thus they should have
	// different names when a name was not explicitly provided.
	var nextDeclareUniqueId = 1;

	module.exports = function declare(name) {
	  if (process.env.NODE_ENV !== 'production') {
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + name + ' supplied to declare([name]) (expected a string)'; });
	  }

	  var type;

	  function Declare(value, path) {
	    if (process.env.NODE_ENV !== 'production') {
	      assert(!isNil(type), function () { return 'Type declared but not defined, don\'t forget to call .define on every declared type'; });
	    }
	    return type(value, path);
	  }

	  Declare.define = function (spec) {
	    if (process.env.NODE_ENV !== 'production') {
	      assert(isType(spec), function () { return 'Invalid argument type ' + assert.stringify(spec) +  ' supplied to define(type) (expected a type)'; });
	      assert(isNil(type), function () { return 'Declare.define(type) can only be invoked once'; });
	      assert(isNil(spec.meta.name) && Object.keys(spec.prototype).length === 0, function () { return 'Invalid argument type ' + assert.stringify(spec) + ' supplied to define(type) (expected a fresh, unnamed type)'; });
	    }

	    type = spec;
	    mixin(Declare, type, true); // true because it overwrites Declare.displayName
	    if (name) {
	      type.displayName = Declare.displayName = name;
	      Declare.meta.name = name;
	    }
	    // ensure identity is still false
	    Declare.meta.identity = false;
	    Declare.prototype = type.prototype;
	    return Declare;
	  };

	  Declare.displayName = name || ( getTypeName(Declare) + "$" + nextDeclareUniqueId++ );
	  // in general I can't say if this type will be an identity, for safety setting to false
	  Declare.meta = { identity: false };
	  Declare.prototype = null;
	  return Declare;
	};

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 35 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var isNil = __webpack_require__(3);
	var assert = __webpack_require__(1);

	// safe mixin, cannot override props unless specified
	module.exports = function mixin(target, source, overwrite) {
	  if (isNil(source)) { return target; }
	  for (var k in source) {
	    if (source.hasOwnProperty(k)) {
	      if (overwrite !== true) {
	        if (process.env.NODE_ENV !== 'production') {
	          assert(!target.hasOwnProperty(k), function () { return 'Invalid call to mixin(target, source, [overwrite]): cannot overwrite property "' + k + '" of target object'; });
	        }
	      }
	      target[k] = source[k];
	    }
	  }
	  return target;
	};
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 36 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var forbidNewOperator = __webpack_require__(10);
	var isString = __webpack_require__(9);
	var isObject = __webpack_require__(13);

	function getDefaultName(map) {
	  return Object.keys(map).map(function (k) { return assert.stringify(k); }).join(' | ');
	}

	function enums(map, name) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isObject(map), function () { return 'Invalid argument map ' + assert.stringify(map) + ' supplied to enums(map, [name]) combinator (expected a dictionary of String -> String | Number)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to enums(map, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(map);

	  function Enums(value, path) {

	    if (process.env.NODE_ENV !== 'production') {
	      forbidNewOperator(this, Enums);
	      path = path || [displayName];
	      assert(Enums.is(value), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/') + ' (expected one of ' + assert.stringify(Object.keys(map)) + ')'; });
	    }

	    return value;
	  }

	  Enums.meta = {
	    kind: 'enums',
	    map: map,
	    name: name,
	    identity: true
	  };

	  Enums.displayName = displayName;

	  Enums.is = function (x) {
	    return map.hasOwnProperty(x);
	  };

	  return Enums;
	}

	enums.of = function (keys, name) {
	  keys = isString(keys) ? keys.split(' ') : keys;
	  var value = {};
	  keys.forEach(function (k) {
	    value[k] = k;
	  });
	  return enums(value, name);
	};

	enums.getDefaultName = getDefaultName;
	module.exports = enums;


	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 37 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var isFunction = __webpack_require__(2);
	var getTypeName = __webpack_require__(11);
	var isIdentity = __webpack_require__(30);
	var create = __webpack_require__(31);
	var is = __webpack_require__(33);
	var isArray = __webpack_require__(14);

	function getDefaultName(type) {
	  return 'Array<' + getTypeName(type) + '>';
	}

	function list(type, name) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isFunction(type), function () { return 'Invalid argument type ' + assert.stringify(type) + ' supplied to list(type, [name]) combinator (expected a type)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to list(type, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(type);
	  var typeNameCache = getTypeName(type);
	  var identity = isIdentity(type); // the list is identity iif type is identity

	  function List(value, path) {

	    if (process.env.NODE_ENV === 'production') {
	      if (identity) {
	        return value; // just trust the input if elements must not be hydrated
	      }
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      path = path || [displayName];
	      assert(isArray(value), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/') + ' (expected an array of ' + typeNameCache + ')'; });
	    }

	    var idempotent = true; // will remain true if I can reutilise the input
	    var ret = []; // make a temporary copy, will be discarded if idempotent remains true
	    for (var i = 0, len = value.length; i < len; i++ ) {
	      var actual = value[i];
	      var instance = create(type, actual, ( process.env.NODE_ENV !== 'production' ? path.concat(i + ': ' + typeNameCache) : null ));
	      idempotent = idempotent && ( actual === instance );
	      ret.push(instance);
	    }

	    if (idempotent) { // implements idempotency
	      ret = value;
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      Object.freeze(ret);
	    }

	    return ret;
	  }

	  List.meta = {
	    kind: 'list',
	    type: type,
	    name: name,
	    identity: identity
	  };

	  List.displayName = displayName;

	  List.is = function (x) {
	    return isArray(x) && x.every(function (e) {
	      return is(e, type);
	    });
	  };

	  List.update = function (instance, patch) {
	    return List(assert.update(instance, patch));
	  };

	  return List;
	}

	list.getDefaultName = getDefaultName;
	module.exports = list;

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 38 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var isFunction = __webpack_require__(2);
	var isMaybe = __webpack_require__(39);
	var isIdentity = __webpack_require__(30);
	var Any = __webpack_require__(6);
	var create = __webpack_require__(31);
	var Nil = __webpack_require__(22);
	var forbidNewOperator = __webpack_require__(10);
	var is = __webpack_require__(33);
	var getTypeName = __webpack_require__(11);

	function getDefaultName(type) {
	  return '?' + getTypeName(type);
	}

	function maybe(type, name) {

	  if (isMaybe(type) || type === Any || type === Nil) { // makes the combinator idempotent and handle Any, Nil
	    return type;
	  }

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isFunction(type), function () { return 'Invalid argument type ' + assert.stringify(type) + ' supplied to maybe(type, [name]) combinator (expected a type)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to maybe(type, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(type);

	  function Maybe(value, path) {
	    if (process.env.NODE_ENV !== 'production') {
	      forbidNewOperator(this, Maybe);
	    }
	    return Nil.is(value) ? value : create(type, value, path);
	  }

	  Maybe.meta = {
	    kind: 'maybe',
	    type: type,
	    name: name,
	    identity: isIdentity(type)
	  };

	  Maybe.displayName = displayName;

	  Maybe.is = function (x) {
	    return Nil.is(x) || is(x, type);
	  };

	  return Maybe;
	}

	maybe.getDefaultName = getDefaultName;
	module.exports = maybe;

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 39 */
/***/ function(module, exports, __webpack_require__) {

	var isType = __webpack_require__(12);

	module.exports = function isMaybe(x) {
	  return isType(x) && ( x.meta.kind === 'maybe' );
	};

/***/ },
/* 40 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var isFunction = __webpack_require__(2);
	var forbidNewOperator = __webpack_require__(10);
	var isIdentity = __webpack_require__(30);
	var create = __webpack_require__(31);
	var is = __webpack_require__(33);
	var getTypeName = __webpack_require__(11);
	var getFunctionName = __webpack_require__(15);

	function getDefaultName(type, predicate) {
	  return '{' + getTypeName(type) + ' | ' + getFunctionName(predicate) + '}';
	}

	function refinement(type, predicate, name) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isFunction(type), function () { return 'Invalid argument type ' + assert.stringify(type) + ' supplied to refinement(type, predicate, [name]) combinator (expected a type)'; });
	    assert(isFunction(predicate), function () { return 'Invalid argument predicate supplied to refinement(type, predicate, [name]) combinator (expected a function)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to refinement(type, predicate, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(type, predicate);
	  var identity = isIdentity(type);

	  function Refinement(value, path) {

	    if (process.env.NODE_ENV !== 'production') {
	      forbidNewOperator(this, Refinement);
	      path = path || [displayName];
	    }

	    var x = create(type, value, path);

	    if (process.env.NODE_ENV !== 'production') {
	      assert(predicate(x), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/'); });
	    }

	    return x;
	  }

	  Refinement.meta = {
	    kind: 'subtype',
	    type: type,
	    predicate: predicate,
	    name: name,
	    identity: identity
	  };

	  Refinement.displayName = displayName;

	  Refinement.is = function (x) {
	    return is(x, type) && predicate(x);
	  };

	  Refinement.update = function (instance, patch) {
	    return Refinement(assert.update(instance, patch));
	  };

	  return Refinement;
	}

	refinement.getDefaultName = getDefaultName;
	module.exports = refinement;

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 41 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var String = __webpack_require__(27);
	var Function = __webpack_require__(21);
	var isArray = __webpack_require__(14);
	var isObject = __webpack_require__(13);
	var create = __webpack_require__(31);
	var mixin = __webpack_require__(35);
	var isStruct = __webpack_require__(32);
	var getTypeName = __webpack_require__(11);
	var dict = __webpack_require__(28);

	function getDefaultName(props) {
	  return '{' + Object.keys(props).map(function (prop) {
	    return prop + ': ' + getTypeName(props[prop]);
	  }).join(', ') + '}';
	}

	function extend(mixins, name) {
	  if (process.env.NODE_ENV !== 'production') {
	    assert(isArray(mixins) && mixins.every(function (x) {
	      return isObject(x) || isStruct(x);
	    }), function () { return 'Invalid argument mixins supplied to extend(mixins, name), expected an array of objects or structs'; });
	  }
	  var props = {};
	  var prototype = {};
	  mixins.forEach(function (struct) {
	    if (isObject(struct)) {
	      mixin(props, struct);
	    }
	    else {
	      mixin(props, struct.meta.props);
	      mixin(prototype, struct.prototype);
	    }
	  });
	  var ret = struct(props, name);
	  mixin(ret.prototype, prototype);
	  return ret;
	}

	function struct(props, name) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(dict(String, Function).is(props), function () { return 'Invalid argument props ' + assert.stringify(props) + ' supplied to struct(props, [name]) combinator (expected a dictionary String -> Type)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to struct(props, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(props);

	  function Struct(value, path) {

	    if (Struct.is(value)) { // implements idempotency
	      return value;
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      path = path || [displayName];
	      assert(isObject(value), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/') + ' (expected an object)'; });
	    }

	    if (!(this instanceof Struct)) { // `new` is optional
	      return new Struct(value, path);
	    }

	    for (var k in props) {
	      if (props.hasOwnProperty(k)) {
	        var expected = props[k];
	        var actual = value[k];
	        this[k] = create(expected, actual, ( process.env.NODE_ENV !== 'production' ? path.concat(k + ': ' + getTypeName(expected)) : null ));
	      }
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      Object.freeze(this);
	    }

	  }

	  Struct.meta = {
	    kind: 'struct',
	    props: props,
	    name: name,
	    identity: false
	  };

	  Struct.displayName = displayName;

	  Struct.is = function (x) {
	    return x instanceof Struct;
	  };

	  Struct.update = function (instance, patch) {
	    return new Struct(assert.update(instance, patch));
	  };

	  Struct.extend = function (structs, name) {
	    return extend([Struct].concat(structs), name);
	  };

	  return Struct;
	}

	struct.getDefaultName = getDefaultName;
	struct.extend = extend;
	module.exports = struct;

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 42 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var isFunction = __webpack_require__(2);
	var getTypeName = __webpack_require__(11);
	var isIdentity = __webpack_require__(30);
	var isArray = __webpack_require__(14);
	var create = __webpack_require__(31);
	var is = __webpack_require__(33);

	function getDefaultName(types) {
	  return '[' + types.map(getTypeName).join(', ') + ']';
	}

	function tuple(types, name) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isArray(types) && types.every(isFunction), function () { return 'Invalid argument types ' + assert.stringify(types) + ' supplied to tuple(types, [name]) combinator (expected an array of types)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to tuple(types, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(types);
	  var identity = types.every(isIdentity);

	  function Tuple(value, path) {

	    if (process.env.NODE_ENV === 'production') {
	      if (identity) {
	        return value;
	      }
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      path = path || [displayName];
	      assert(isArray(value) && value.length === types.length, function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/') + ' (expected an array of length ' + types.length + ')'; });
	    }

	    var idempotent = true;
	    var ret = [];
	    for (var i = 0, len = types.length; i < len; i++) {
	      var expected = types[i];
	      var actual = value[i];
	      var instance = create(expected, actual, ( process.env.NODE_ENV !== 'production' ? path.concat(i + ': ' + getTypeName(expected)) : null ));
	      idempotent = idempotent && ( actual === instance );
	      ret.push(instance);
	    }

	    if (idempotent) { // implements idempotency
	      ret = value;
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      Object.freeze(ret);
	    }

	    return ret;
	  }

	  Tuple.meta = {
	    kind: 'tuple',
	    types: types,
	    name: name,
	    identity: identity
	  };

	  Tuple.displayName = displayName;

	  Tuple.is = function (x) {
	    return isArray(x) &&
	      x.length === types.length &&
	      types.every(function (type, i) {
	        return is(x[i], type);
	      });
	  };

	  Tuple.update = function (instance, patch) {
	    return Tuple(assert.update(instance, patch));
	  };

	  return Tuple;
	}

	tuple.getDefaultName = getDefaultName;
	module.exports = tuple;
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 43 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var isFunction = __webpack_require__(2);
	var getTypeName = __webpack_require__(11);
	var isIdentity = __webpack_require__(30);
	var isArray = __webpack_require__(14);
	var create = __webpack_require__(31);
	var is = __webpack_require__(33);
	var forbidNewOperator = __webpack_require__(10);
	var isType = __webpack_require__(12);
	var isUnion = __webpack_require__(44);
	var isNil = __webpack_require__(3);

	function getDefaultName(types) {
	  return types.map(getTypeName).join(' | ');
	}

	function union(types, name) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isArray(types) && types.every(isFunction) && types.length >= 2, function () { return 'Invalid argument types ' + assert.stringify(types) + ' supplied to union(types, [name]) combinator (expected an array of at least 2 types)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to union(types, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(types);
	  var identity = types.every(isIdentity);

	  function Union(value, path) {

	    if (process.env.NODE_ENV === 'production') {
	      if (identity) {
	        return value;
	      }
	    }

	    var type = Union.dispatch(value);
	    if (!type && Union.is(value)) {
	      return value;
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      forbidNewOperator(this, Union);
	      path = path || [displayName];
	      assert(isType(type), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/') + ' (no constructor returned by dispatch)'; });
	      path[path.length - 1] += '(' + getTypeName(type) + ')';
	    }

	    return create(type, value, path);
	  }

	  Union.meta = {
	    kind: 'union',
	    types: types,
	    name: name,
	    identity: identity
	  };

	  Union.displayName = displayName;

	  Union.is = function (x) {
	    return types.some(function (type) {
	      return is(x, type);
	    });
	  };

	  Union.dispatch = function (x) { // default dispatch implementation
	    for (var i = 0, len = types.length; i < len; i++ ) {
	      var type = types[i];
	      if (isUnion(type)) { // handle union of unions
	        var t = type.dispatch(x);
	        if (!isNil(t)) {
	          return t;
	        }
	      }
	      else if (is(x, type)) {
	        return type;
	      }
	    }
	  };

	  Union.update = function (instance, patch) {
	    return Union(assert.update(instance, patch));
	  };

	  return Union;
	}

	union.getDefaultName = getDefaultName;
	module.exports = union;


	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 44 */
/***/ function(module, exports, __webpack_require__) {

	var isType = __webpack_require__(12);

	module.exports = function isUnion(x) {
	  return isType(x) && ( x.meta.kind === 'union' );
	};

/***/ },
/* 45 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var FunctionType = __webpack_require__(21);
	var isArray = __webpack_require__(14);
	var list = __webpack_require__(37);
	var isObject = __webpack_require__(13);
	var create = __webpack_require__(31);
	var isNil = __webpack_require__(3);
	var isBoolean = __webpack_require__(18);
	var tuple = __webpack_require__(42);
	var getFunctionName = __webpack_require__(15);
	var getTypeName = __webpack_require__(11);

	function getDefaultName(domain, codomain) {
	  return '(' + domain.map(getTypeName).join(', ') + ') => ' + getTypeName(codomain);
	}

	function isInstrumented(f) {
	  return FunctionType.is(f) && isObject(f.instrumentation);
	}

	function func(domain, codomain, name) {

	  domain = isArray(domain) ? domain : [domain]; // handle handy syntax for unary functions

	  if (process.env.NODE_ENV !== 'production') {
	    assert(list(FunctionType).is(domain), function () { return 'Invalid argument domain ' + assert.stringify(domain) + ' supplied to func(domain, codomain, [name]) combinator (expected an array of types)'; });
	    assert(FunctionType.is(codomain), function () { return 'Invalid argument codomain ' + assert.stringify(codomain) + ' supplied to func(domain, codomain, [name]) combinator (expected a type)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to func(domain, codomain, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(domain, codomain);

	  function FuncType(value, curried) {

	    if (!isInstrumented(value)) { // automatically instrument the function
	      return FuncType.of(value, curried);
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      assert(FuncType.is(value), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + displayName; });
	    }

	    return value;
	  }

	  FuncType.meta = {
	    kind: 'func',
	    domain: domain,
	    codomain: codomain,
	    name: name,
	    identity: true
	  };

	  FuncType.displayName = displayName;

	  FuncType.is = function (x) {
	    return isInstrumented(x) &&
	      x.instrumentation.domain.length === domain.length &&
	      x.instrumentation.domain.every(function (type, i) {
	        return type === domain[i];
	      }) &&
	      x.instrumentation.codomain === codomain;
	  };

	  FuncType.of = function (f, curried) {

	    if (process.env.NODE_ENV !== 'production') {
	      assert(FunctionType.is(f), function () { return 'Invalid argument f supplied to func.of ' + displayName + ' (expected a function)'; });
	      assert(isNil(curried) || isBoolean(curried), function () { return 'Invalid argument curried ' + assert.stringify(curried) + ' supplied to func.of ' + displayName + ' (expected a boolean)'; });
	    }

	    if (FuncType.is(f)) { // makes FuncType.of idempotent
	      return f;
	    }

	    function fn() {
	      var args = Array.prototype.slice.call(arguments);
	      var len = curried ?
	        args.length :
	        domain.length;
	      var argsType = tuple(domain.slice(0, len));

	      args = argsType(args); // type check arguments

	      if (len === domain.length) {
	        return create(codomain, f.apply(this, args));
	      }
	      else {
	        var g = Function.prototype.bind.apply(f, [this].concat(args));
	        var newdomain = func(domain.slice(len), codomain);
	        return newdomain.of(g, curried);
	      }
	    }

	    fn.instrumentation = {
	      domain: domain,
	      codomain: codomain,
	      f: f
	    };

	    fn.displayName = getFunctionName(f);

	    return fn;

	  };

	  return FuncType;

	}

	func.getDefaultName = getDefaultName;
	module.exports = func;

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 46 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isTypeName = __webpack_require__(29);
	var isFunction = __webpack_require__(2);
	var isArray = __webpack_require__(14);
	var forbidNewOperator = __webpack_require__(30);
	var is = __webpack_require__(33);
	var getTypeName = __webpack_require__(11);

	function getDefaultName(types) {
	  return types.map(getTypeName).join(' & ');
	}

	function intersection(types, name) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isArray(types) && types.every(isFunction) && types.length >= 2, function () { return 'Invalid argument types ' + assert.stringify(types) + ' supplied to intersection(types, [name]) combinator (expected an array of at least 2 types)'; });
	    assert(isTypeName(name), function () { return 'Invalid argument name ' + assert.stringify(name) + ' supplied to intersection(types, [name]) combinator (expected a string)'; });
	  }

	  var displayName = name || getDefaultName(types);

	  function Intersection(value, path) {

	    if (process.env.NODE_ENV !== 'production') {
	      forbidNewOperator(this, Intersection);
	      path = path || [displayName];
	      assert(Intersection.is(value), function () { return 'Invalid value ' + assert.stringify(value) + ' supplied to ' + path.join('/'); });
	    }

	    return value;
	  }

	  Intersection.meta = {
	    kind: 'intersection',
	    types: types,
	    name: name,
	    identity: true
	  };

	  Intersection.displayName = displayName;

	  Intersection.is = function (x) {
	    return types.every(function (type) {
	      return is(x, type);
	    });
	  };

	  Intersection.update = function (instance, patch) {
	    return Intersection(assert.update(instance, patch));
	  };

	  return Intersection;
	}

	intersection.getDefaultName = getDefaultName;
	module.exports = intersection;


	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 47 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isObject = __webpack_require__(13);
	var isFunction = __webpack_require__(2);
	var isArray = __webpack_require__(14);
	var isNumber = __webpack_require__(24);
	var mixin = __webpack_require__(35);

	function getShallowCopy(x) {
	  if (isArray(x)) {
	    return x.concat();
	  }
	  if (x instanceof Date || x instanceof RegExp) {
	    return x;
	  }
	  if (isObject(x)) {
	    return mixin({}, x);
	  }
	  return x;
	}

	function update(instance, patch) {

	  if (process.env.NODE_ENV !== 'production') {
	    assert(isObject(patch), function () { return 'Invalid argument patch ' + assert.stringify(patch) + ' supplied to function update(instance, patch): expected an object containing commands'; });
	  }

	  var value = getShallowCopy(instance);
	  var isChanged = false;
	  for (var k in patch) {
	    if (patch.hasOwnProperty(k)) {
	      if (update.commands.hasOwnProperty(k)) {
	        value = update.commands[k](patch[k], value);
	        isChanged = true;
	      }
	      else {
	        var newValue = update(value[k], patch[k]);
	        isChanged = isChanged || ( newValue !== value[k] );
	        value[k] = newValue;
	      }
	    }
	  }
	  return isChanged ? value : instance;
	}

	// built-in commands

	function $apply(f, value) {
	  if (process.env.NODE_ENV !== 'production') {
	    assert(isFunction(f), 'Invalid argument f supplied to immutability helper { $apply: f } (expected a function)');
	  }
	  return f(value);
	}

	function $push(elements, arr) {
	  if (process.env.NODE_ENV !== 'production') {
	    assert(isArray(elements), 'Invalid argument elements supplied to immutability helper { $push: elements } (expected an array)');
	    assert(isArray(arr), 'Invalid value supplied to immutability helper $push (expected an array)');
	  }
	  return arr.concat(elements);
	}

	function $remove(keys, obj) {
	  if (process.env.NODE_ENV !== 'production') {
	    assert(isArray(keys), 'Invalid argument keys supplied to immutability helper { $remove: keys } (expected an array)');
	    assert(isObject(obj), 'Invalid value supplied to immutability helper $remove (expected an object)');
	  }
	  for (var i = 0, len = keys.length; i < len; i++ ) {
	    delete obj[keys[i]];
	  }
	  return obj;
	}

	function $set(value) {
	  return value;
	}

	function $splice(splices, arr) {
	  if (process.env.NODE_ENV !== 'production') {
	    assert(isArray(splices) && splices.every(isArray), 'Invalid argument splices supplied to immutability helper { $splice: splices } (expected an array of arrays)');
	    assert(isArray(arr), 'Invalid value supplied to immutability helper $splice (expected an array)');
	  }
	  return splices.reduce(function (acc, splice) {
	    acc.splice.apply(acc, splice);
	    return acc;
	  }, arr);
	}

	function $swap(config, arr) {
	  if (process.env.NODE_ENV !== 'production') {
	    assert(isObject(config), 'Invalid argument config supplied to immutability helper { $swap: config } (expected an object)');
	    assert(isNumber(config.from), 'Invalid argument config.from supplied to immutability helper { $swap: config } (expected a number)');
	    assert(isNumber(config.to), 'Invalid argument config.to supplied to immutability helper { $swap: config } (expected a number)');
	    assert(isArray(arr), 'Invalid value supplied to immutability helper $swap (expected an array)');
	  }
	  var element = arr[config.to];
	  arr[config.to] = arr[config.from];
	  arr[config.from] = element;
	  return arr;
	}

	function $unshift(elements, arr) {
	  if (process.env.NODE_ENV !== 'production') {
	    assert(isArray(elements), 'Invalid argument elements supplied to immutability helper {$unshift: elements} (expected an array)');
	    assert(isArray(arr), 'Invalid value supplied to immutability helper $unshift (expected an array)');
	  }
	  return elements.concat(arr);
	}

	function $merge(obj, value) {
	  return mixin(mixin({}, value), obj, true);
	}

	update.commands = {
	  $apply: $apply,
	  $push: $push,
	  $remove: $remove,
	  $set: $set,
	  $splice: $splice,
	  $swap: $swap,
	  $unshift: $unshift,
	  $merge: $merge
	};

	module.exports = update;

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ },
/* 48 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(process) {var assert = __webpack_require__(1);
	var isFunction = __webpack_require__(2);
	var isType = __webpack_require__(12);
	var Any = __webpack_require__(6);

	module.exports = function match(x) {
	  var type, guard, f, count;
	  for (var i = 1, len = arguments.length; i < len; ) {
	    type = arguments[i];
	    guard = arguments[i + 1];
	    f = arguments[i + 2];

	    if (isFunction(f) && !isType(f)) {
	      i = i + 3;
	    }
	    else {
	      f = guard;
	      guard = Any.is;
	      i = i + 2;
	    }

	    if (process.env.NODE_ENV !== 'production') {
	      count = (count || 0) + 1;
	      assert(isType(type), function () { return 'Invalid type in clause #' + count; });
	      assert(isFunction(guard), function () { return 'Invalid guard in clause #' + count; });
	      assert(isFunction(f), function () { return 'Invalid block in clause #' + count; });
	    }

	    if (type.is(x) && guard(x)) {
	      return f(x);
	    }
	  }
	  assert.fail('Match error');
	};

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(8)))

/***/ }
/******/ ]);